rem *********************************
rem	puzzle.bas
rem *********************************

rem def int a-z

'open "t.t" for output as #1
'tron line #1

if_debug 1: e= 10: open error as 10

on error goto hay_error

rem Cambiar esto de acuerdo a gustos o necesidades del sistema
default_zoom= 2

rem Para probar varias formas
usa_scroll= not 0
usa_paint= 0
despacio= 0

arg= 1

label otro_arg

arg$= programarg$ (arg)

if arg$ = "-paint" then usa_paint= not 0: arg= arg + 1: goto otro_arg

if arg$ = "-put" then usa_scroll= 0: arg= arg + 1: goto otro_arg

if arg$ = "-slow" then despacio= val (programarg$ (arg + 1) ): arg= arg + 2: goto otro_arg

zoom= val (arg$)
if zoom = 0 then zoom = default_zoom

xpart= val (programarg$ (arg + 1) )
ypart= val (programarg$ (arg + 2) )
if xpart = 0 then xpart= 5
if ypart = 0 then ypart= 4

if xpart * ypart > 100 then print "Valores inadecuados, se admiten 100 numeros como mucho": exit 1

dim solucion (xpart, ypart)
dim tablero (xpart, ypart)

n= 1
for y= 1 to ypart
	for x= 1 to xpart
		solucion (x, y)= n
		n= n + 1
	next
next
solucion (xpart, ypart)= 0

gosub define_funciones

rem Dimensiones de cada pieza del puzzle
xpieza= 21 * zoom
ypieza= 13 * zoom

anchotab= xpart * xpieza + zoom
altotab= ypart * ypieza + zoom

pixchar= 8 * zoom
anchotex= 13 * pixchar
altotex= 5 * pixchar

ancho= max (anchotab, anchotex)
alto= max (altotab, altotex)

xoff= (ancho - anchotab) \ 2
yoff= (alto - altotab) \ 2

xcoff= (ancho - anchotex) \ (pixchar * 2)
ycoff= (alto - altotex) \ (pixchar * 2)

fondo= 14
border fondo
border width zoom * 2

rem El IF es para compatibilidad descendente cuando se usa zoom 1
if zoom = 1 then mode ancho, alto else mode ancho, alto, 0, zoom, zoom

esc$= chr$ (27)

transp$= chr$ (22) + chr$ (1)
notransp$= chr$ (22) + chr$ (0)

paper fondo
graphics paper fondo
graphics cls
print transp$;


repeat
	print at ycoff + 0, xcoff + 3; "PUZZLE"
	print at ycoff + 2, xcoff + 0; "ESC --> Fin"
	print at ycoff + 4, xcoff + 0; "Otra--> jugar";
	clear input

	label pide_opcion
	repeat
		get opcion$
	until opcion$ <> "RELEASE"
	if opcion$ <> "CLICK" then goto elegido

	y= int (ymouse / 8 / zoom) - ycoff
	repeat
		get t$
	until t$ = "RELEASE"
	if y = 2 then opcion$= esc$ else if y <> 4 then goto pide_opcion

	label elegido
	graphics cls
	if opcion$ <> esc$ then gosub partida

until opcion$ = esc$

end

rem ******************************************
	label partida
rem ******************************************

tag
gosub barajar
gosub pinta_tablero
ganador= 0
inicio= time

repeat
	get a$
	if a$ ="r" then gosub pinta_tablero
	if a$ = "CLICK" then gosub raton
	if a$ = "LEFT" then void= fn izquierda (1)
	if a$ = "RIGHT" then void= fn derecha (1)
	if a$ = "UP" then void= fn arriba (1)
	if a$ = "DOWN" then void= fn abajo (1)

	tablero (xblanco, yblanco)= 0

	if fn victoria then ganador=1: a$= esc$
until a$ = esc$

tiempo= time - inicio
tiempo$= trim$ (str$ (tiempo) )
post= 5 - (len (tiempo$) - 1) \ 2

tagoff

graphics cls

if ganador = 0 then return

beep

for j= 1 to 2
	for i= 15 to 0 step -1
		if i = fondo then goto gana_next
		pen i
		print at ycoff + 1, xcoff + 1; "HAS GANADO"
		print at ycoff + 3, xcoff + 3; "Tiempo"
		print at ycoff + 4, xcoff + post; tiempo$
		pause 100
		label gana_next
	next
next
beep
clear input
get a$
graphics cls

return ' Partida


label raton

xx= xmouse - xoff: yy= ymouse - yoff
x= int (xx / xpieza) + 1
y= int (yy / ypieza) + 1
if x > xpart or y > ypart then goto fin_raton

if yblanco = y then goto horizontal else goto vertical

label horizontal

if xblanco = x then goto fin_raton

if xblanco > x then goto derecha

void= fn izquierda (x - xblanco)

goto fin_raton

label derecha

void= fn derecha (xblanco - x)

goto fin_raton

label vertical

if xblanco <> x then goto  fin_raton
if yblanco = y then goto fin_raton
if yblanco > y then goto abajo

void= fn arriba (y - yblanco)

goto fin_raton

label abajo

void= fn abajo (yblanco - y)

label fin_raton

return


rem ****************************************
	label define_funciones
rem ****************************************

def fn xx (x)= (x - 1) * xpieza + xoff
def fn yy (y)= (y - 1) * ypieza + yoff

rem ****************************************
	def fn izquierda (n)
rem ****************************************

if xblanco + n > xpart then fn return

for i= xblanco to xblanco + n - 1
	tablero (i, yblanco)= tablero (i + 1, yblanco)
next
void= fn move_izq (xblanco + 1, yblanco, n)

xblanco= xblanco + n

fn end

rem ****************************************
	def fn derecha (n)
rem ****************************************

if xblanco - n < 1 then fn return

for i= xblanco to xblanco - n step -1
	tablero (i, yblanco)= tablero (i - 1, yblanco)
next
void= fn move_der (xblanco - n, yblanco, n)

xblanco= xblanco - n

fn end

rem ****************************************
	def fn arriba (n)
rem ****************************************

if yblanco + n > ypart then fn return

for i= yblanco to yblanco + n - 1
	tablero (xblanco, i)= tablero (xblanco, i + 1)
next
void= fn move_arr (xblanco, yblanco + 1, n)

yblanco= yblanco + n

fn end

rem ****************************************
	def fn abajo (n)
rem ****************************************

if yblanco - n < 1 then fn return

for i= yblanco to yblanco - n step - 1
	tablero (xblanco, i)= tablero (xblanco, i - 1)
next
void= fn move_abj (xblanco, yblanco - n, n)

yblanco= yblanco - n

fn end

rem ****************************************
	def fn move_izq (x, y, n)
rem ****************************************

local xx, yy, xx2, yy2, i

if_debug 1 : print #e, x, y, n

xx= fn xx (x)
yy= fn yy (y)
xx2= xx + (xpieza * n) 
yy2= yy + ypieza

if not usa_scroll then get (xx, yy)-(xx2, yy2), g

for i= xx - zoom to xx - xpieza step -zoom
	if usa_scroll then graphics scroll xx - xpieza, yy, xx2, yy2, -zoom, 0 else put (i, yy), g
	if despacio then pause despacio
next

fn end

rem ****************************************
	def fn move_der (x, y, n)
rem ****************************************

local xx, yy, xx2, yy2, i

if_debug 1 : print #e, x, y, n

xx= fn xx (x)
yy= fn yy (y)
xx2= xx + (xpieza * n) 
yy2= yy + ypieza

if not usa_scroll then get (xx, yy)-(xx2, yy2), g

for i= xx + zoom to xx + xpieza step zoom
	if usa_scroll then graphics scroll xx, yy, xx2 + xpieza, yy2, zoom, 0 else put (i, yy), g
	if despacio then pause despacio
next

fn end

rem ****************************************
	def fn move_arr (x, y, n)
rem ****************************************

local xx, yy, xx2, yy2, i

xx= fn xx (x)
yy= fn yy (y)
xx2= xx + xpieza
yy2= yy + (ypieza * n)

if not usa_scroll then get (xx, yy)-(xx2, yy2), g

for i= yy - zoom to yy - ypieza step -zoom
	if usa_scroll then graphics scroll xx, yy - ypieza, xx2, yy2, 0, -zoom else put (xx, i), g
	if despacio then pause despacio
next

fn end

rem ****************************************
	def fn move_abj (x, y, n)
rem ****************************************

local xx, yy, xx2, yy2, i

xx= fn xx (x)
yy= fn yy (y)
xx2= xx + xpieza
yy2= yy + (ypieza * n)

if not usa_scroll then get (xx, yy)-(xx2, yy2), g

for i= yy + zoom to yy + ypieza step zoom
	if usa_scroll then graphics scroll xx, yy, xx2, yy2 + ypieza, 0, zoom else put (xx, i), g
	if despacio then pause despacio
next

fn end

rem ****************************************
	def fn pinta_pieza (x, y)
rem ****************************************

local p

p= tablero (x, y)

if p = 0 then fn return

local xx, yy, xx2, yy2, z

z= zoom
xx= fn xx (x) + z
yy= fn yy (y) + z
xx2= fn xx (x) + xpieza - z
yy2= fn yy (y) + ypieza - z

graphics pen 0

line (xx, yy) - (xx2, yy2), , bf

if usa_paint then graphics pen 15 else graphics pen 3

line (xx + zoom, yy + zoom) - (xx2 - zoom, yy2 - zoom), , bf

if usa_paint then paint (xx + zoom + 1, yy + zoom + 1), 3, 0

graphics pen 0
xnum= xx + 2 * zoom
if p < 10 then xnum= xnum + pixchar \ 2
move xnum, yy + 2 * zoom
print trim$ (str$ (p) );

'if usa_paint then paint (xx + zoom + 1, yy + zoom + 1), 3, 0

fn end

rem ****************************************
	def fn victoria
rem ****************************************

local x, y

victoria= 1

for y= 1 to ypart
	for x= 1 to xpart
		if tablero (x, y) <> solucion (x, y) then victoria= 0
next x, y

fn end

return ' define_funciones

rem ****************************************
	label pinta_tablero
rem ****************************************

graphics cls

local x, y

for y= 1 to ypart
	for x= 1 to xpart
		void= fn pinta_pieza (x, y)
	next
next

return

rem ****************************************
	label inicia_tablero
rem ****************************************

local y

for y= 1 to ypart
	for x= 1 to xpart
		tablero (x, y)= solucion (x, y)
	next
next

return

rem ****************************************
	label barajar
rem ****************************************

randomize time

gosub inicia_tablero

x= xpart
y= ypart

for b= 1 to 500
	j= 1 + int (rnd * 4)
	on j gosub barizq, barder, bararr, baraba
next

xblanco= x: yblanco= y

return

label barizq
if x = 1 then return
tablero (x, y)= tablero (x - 1, y)
x= x - 1
tablero (x, y) = 0
return

label barder
if x = xpart then return
tablero (x, y)= tablero (x + 1, y)
x= x + 1
tablero (x, y)= 0
return

label bararr
if y = 1 then return
tablero (x, y)= tablero (x, y - 1)
y= y - 1
tablero (x, y)= 0
return

label baraba
if y = ypart then return
tablero (x, y)= tablero (x, y + 1)
y= y + 1
tablero (x, y)= 0
return

label hay_error
on error goto 0
mode 0
print "Error: "; strerr$ (err); " en linea "; erl
end

rem **************************************
rem	Fin de puzzle.bas
rem **************************************
